﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Markup;
using System.Windows.Threading;

namespace Tri
{
 public partial class Page : UserControl
 {
  const int CellW = 50, CellH = 50;
  Random rndm;
  int[] tabNombres;
  Rectangle[] tabRectangles;
  TextBlock[] tabTbValeurs;
  DispatcherTimer timer;
  public Page()
  {
   InitializeComponent();
  }

  private void LayoutRoot_Loaded(object sender, RoutedEventArgs e)
  {
   tabNombres = new int[9];   // tableau de nombres au hasard à trier
   tabRectangles = new Rectangle[9];  // tableau des rectangles représentant ces nombres
   tabTbValeurs = new TextBlock[9];    // tableau des TextBlock affichant ces valeurs
   for (int i = 0; i < 9; i++) // créer les 9 TextBlock contenant ces valeurs
   {
    TextBlock tb = new TextBlock();
    tb.SetValue(Canvas.LeftProperty, (double)(60 + i * 75));
    tb.SetValue(Canvas.TopProperty, 500.0);
    tb.SetValue(TextBlock.NameProperty, "tb" + i);
    tb.FontSize = 30;
    tb.Foreground = new SolidColorBrush(Colors.Black);
    tb.Text = "";
    tabTbValeurs[i] = tb;
    LayoutRoot.Children.Add(tb);
   }
   timer = new DispatcherTimer();
   timer.Interval = new TimeSpan(0, 0,  0, 0, 500);
   timer.Tick += new EventHandler(timer_Tick);
  }

  void resetValues()
  {
   animCanvas.Children.Clear();
   for (int i = 0; i < 9; i++)
   {
    tabTbValeurs[i].Foreground = new SolidColorBrush(Colors.Black);
    tabTbValeurs[i].Text = "";
   }
  }

  void InitialisationDesValeurs()
  {
   rndm = new Random();
   for (int i = 0; i < 9; i++)   // 9 nombres au hasard entre (inclus) 1 and 9 
   {
    int N = rndm.Next(1, 10);
    tabNombres[i] = N;
    InitialiserValeur(i, N);
   }
  }

  void InitialiserValeur(int i, int N)
  {
   // créer un rectangle représentant un nombre au hasard
   Rectangle r = new Rectangle();
   r.SetValue(Rectangle.NameProperty, "rc" + i);
   r.SetValue(Canvas.LeftProperty, 50.0 + (i * 75));
   r.SetValue(Canvas.TopProperty, 0.0);
   r.Width = 50;
   r.Fill = new SolidColorBrush(Colors.Black);
   
   Storyboard stb = new Storyboard();
   stb.Duration = new Duration(new TimeSpan(0, 0, 0, 2, 500));
   DoubleAnimationUsingKeyFrames dakf = new DoubleAnimationUsingKeyFrames();
   SplineDoubleKeyFrame sdkf = new SplineDoubleKeyFrame();
   sdkf.KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0));
   sdkf.Value = Math.Min(10 * CellH, (N + 5) * CellH);
   dakf.KeyFrames.Add(sdkf);
   sdkf = new SplineDoubleKeyFrame();
   sdkf.KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 250));
   sdkf.Value = Math.Max(0, (N - 5) * CellH);
   dakf.KeyFrames.Add(sdkf);
   sdkf = new SplineDoubleKeyFrame();
   sdkf.KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 500));
   sdkf.Value = Math.Min(10 * CellH, (N + 2) * CellH);
   dakf.KeyFrames.Add(sdkf);
   sdkf = new SplineDoubleKeyFrame();
   sdkf.KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 750));
   sdkf.Value = Math.Max(0, (N - 2) * CellH);
   dakf.KeyFrames.Add(sdkf);
   sdkf = new SplineDoubleKeyFrame();
   sdkf.KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 1000));
   sdkf.Value = Math.Min(10 * CellH, (N + 1) * CellH);
   dakf.KeyFrames.Add(sdkf);
   sdkf = new SplineDoubleKeyFrame();
   sdkf.KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 1, 250));
   sdkf.Value = Math.Max(0, (N - 1) * CellH);
   dakf.KeyFrames.Add(sdkf);
   sdkf = new SplineDoubleKeyFrame();
   sdkf.KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 1, 500));
   sdkf.Value = N * CellH;
   dakf.KeyFrames.Add(sdkf);
   Storyboard.SetTargetProperty(dakf, new PropertyPath("Height"));
   dakf.BeginTime = new TimeSpan(0, 0, 0, 0, 100 * i);
   stb.Children.Add(dakf);
   r.Resources.Add("Storyboard", stb);

   Storyboard stbRcBlink = new Storyboard();
   stbRcBlink.SetValue(NameProperty, "stbRc" + i + "Blink");
   DoubleAnimation da = new DoubleAnimation();
   Storyboard.SetTargetProperty(da, new PropertyPath("Opacity"));
   Storyboard.SetTarget(stbRcBlink, r);
   da.AutoReverse = true;
   da.RepeatBehavior = RepeatBehavior.Forever;
   da.Duration = new Duration(new TimeSpan(0, 0, 0, 0, 500));
   stbRcBlink.Children.Add(da);
   r.Resources.Add("Storyboard2", stbRcBlink);

   tabRectangles[i] = r;
   animCanvas.Children.Add(r);

   Storyboard.SetTargetName(stb, "rc" + i);
   stb.Completed += new EventHandler(stbRcInitAnim_Completed);  
   stb.Begin();
  }

  void stbRcInitAnim_Completed(object sender, EventArgs e)
  {
   // afficher les 9 valeurs aussitôt que l'animation est terminée
   for (int i = 0; i < 9; i++) tabTbValeurs[i].Text = tabNombres[i].ToString();
  }

  enum Etapes { Présentation, Comparaison, NextBoucle };
  int N1, N2,
      iPlusPetit, // index du plus petit courant
      nPlusPetit; // valeur du plus petit courant
  Etapes nextEtape;
  bool bRectanglesEnCoursDepl;

  void timer_Tick(object sender, EventArgs e)
  {
   if (bRectanglesEnCoursDepl) return;
   Storyboard stb;
   switch (nextEtape)
   {
    case Etapes.NextBoucle: // démarrer une nouvelle boucle
     if (N1 >= 8)
     {
      tabRectangles[8].Fill = new SolidColorBrush(Colors.Blue);
      tabTbValeurs[8].Foreground = new SolidColorBrush(Colors.Blue);
      return;    // fin du tri
     }
     // N1 est candidat à l'échange. Nous allons essayer de trouver un plus petit nombre dans la suite à droite
     tabRectangles[N1].Fill = new SolidColorBrush(Colors.Red);
     N2 = N1 + 1; iPlusPetit = -1; nPlusPetit = 100;
     stb = (Storyboard)FindName("stbRc" + N1 + "Blink"); // montrer que N1 est candidat à l'échange
     stb.Begin();
     nextEtape = Etapes.Comparaison;
     timer.Start();
     break;

    case Etapes.Présentation:
     // montrer le rectangle qui est en cours de comparaison
     tabRectangles[N2].Fill = new SolidColorBrush(Colors.Green);
     nextEtape = Etapes.Comparaison;
     if (N2 > 8) Exchange();       // fin de suite à droite
     timer.Start();
     break;

    case Etapes.Comparaison:
     tabRectangles[N2].Fill = new SolidColorBrush(Colors.Black);
     if (tabNombres[N2] < tabNombres[N1])
     {
      // plus petit que le plus petit précédent ?
      if (tabNombres[N2] < nPlusPetit)
      {
       if (iPlusPetit != -1)
       {
        // mettre fin au clignotement 
        tabRectangles[iPlusPetit].Fill = new SolidColorBrush(Colors.Black);
        stb = (Storyboard)FindName("stbRc" + iPlusPetit + "Blink");
        stb.Stop();
       }
       // montrer que le nouveau "plus petit" est candidat à l'échange
       tabRectangles[N2].Fill = new SolidColorBrush(Colors.Red);
       stb = (Storyboard)FindName("stbRc" + N2 + "Blink");
       iPlusPetit = N2; nPlusPetit = tabNombres[N2];
       stb.Begin();
      }

     }
     if (N2 == 8) // fin de boucle, peut-être faut-il procéder à l'échange  
     {
      Exchange();
      return;
     }
     nextEtape = Etapes.Présentation;
     N2++;
     timer.Start();
     break;
   }
  }

  void Exchange()
  {
   // deux nombres (en N1 et iSmallest) sont candidat à l'échange
   if (iPlusPetit != 8) tabRectangles[8].Fill = new SolidColorBrush(Colors.Black);
   Storyboard stb;
   if (iPlusPetit != -1)
   {
    bRectanglesEnCoursDepl = true;
    // démarrer le déplacement
    // mettre fin au clignotement des deux candidats
    stb = (Storyboard)FindName("stbRc" + N1 + "Blink");
    stb.Stop();
    stb = (Storyboard)FindName("stbRc" + iPlusPetit + "Blink");
    stb.Stop();

    // les deux candidats à l'échange sont remplavcés par des rectangles jaunes en mouvement
    tabRectangles[N1].Opacity = 0;
    tabRectangles[iPlusPetit].Opacity = 0;

    // préparer le rectangle jaune en mouvement de gauche à droite
    rcMove1.Opacity = 1;
    double left = (double)tabRectangles[N1].GetValue(Canvas.LeftProperty);
    rcMove1.SetValue(Canvas.LeftProperty, left);
    double top = (double)tabRectangles[N1].GetValue(Canvas.TopProperty);
    rcMove1.SetValue(Canvas.TopProperty, top);
    rcMove1.Width = tabRectangles[N1].Width;
    rcMove1.Height = tabRectangles[N1].Height;
    daMove1.To = (double)tabRectangles[iPlusPetit].GetValue(Canvas.LeftProperty);
    stbRcMove1.Begin();

    // préparer le rectangle jaune en mouvement de droite à gauche
    rcMove2.Opacity = 1;
    left = (double)tabRectangles[iPlusPetit].GetValue(Canvas.LeftProperty);
    rcMove2.SetValue(Canvas.LeftProperty, left);
    top = (double)tabRectangles[iPlusPetit].GetValue(Canvas.TopProperty);
    rcMove2.SetValue(Canvas.TopProperty, top);
    rcMove2.Width = tabRectangles[iPlusPetit].Width;
    rcMove2.Height = tabRectangles[iPlusPetit].Height;
    daMove2.To = (double)tabRectangles[N1].GetValue(Canvas.LeftProperty);
    stbRcMove2.Begin();
   }
   else
   {
    // aucun échange à effectuer
    stb = (Storyboard)FindName("stbRc" + N1 + "Blink");
    stb.Stop();
    tabRectangles[N1].Fill = new SolidColorBrush(Colors.Blue);
    tabTbValeurs[N1].Foreground = new SolidColorBrush(Colors.Blue);
    N1++; nextEtape = Etapes.NextBoucle;
    timer.Start();
   }
   if (N1 >= 8)
   {
    tabRectangles[8].Fill = new SolidColorBrush(Colors.Blue);
    tabTbValeurs[8].Foreground = new SolidColorBrush(Colors.Blue);
   }

  }

  void stbRcMove2_Completed(object sender, EventArgs e)
  {
   // fin animation de déplacement
   rcMove1.Opacity = 0; rcMove2.Opacity = 0;
   tabRectangles[N1].Height = tabNombres[iPlusPetit] * CellH;
   tabRectangles[N1].Fill = new SolidColorBrush(Colors.Blue); // N1 est correctement placé

   // procéder à l'échange
   int n = tabNombres[N1];
   tabNombres[N1] = tabNombres[iPlusPetit];
   tabTbValeurs[N1].Text = tabNombres[iPlusPetit].ToString();
   tabNombres[iPlusPetit] = n;
   tabRectangles[N1].Opacity = 1;
   tabTbValeurs[N1].Foreground = new SolidColorBrush(Colors.Blue);

   tabRectangles[iPlusPetit].Height = n * CellH;
   tabRectangles[iPlusPetit].Fill = new SolidColorBrush(Colors.Black);
   tabTbValeurs[iPlusPetit].Text = n.ToString();
   tabRectangles[iPlusPetit].Opacity = 1;

   bRectanglesEnCoursDepl = false;

   N1++; nextEtape = Etapes.NextBoucle;
  }

  private void bGenerateNumbers_Click(object sender, RoutedEventArgs e)
  {
   timer.Stop(); if (bRectanglesEnCoursDepl) return;
   resetValues();
   InitialisationDesValeurs();
  }

  private void bTri_Click(object sender, RoutedEventArgs e)
  {
   N1 = 0; nextEtape = Etapes.NextBoucle;
   timer.Start();
  } 
 }
}
